package keesun;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public class ListManager {

	private List<String> items;

	private Set<String> subItems = new HashSet<String>();

	private List<Integer> subIndexis = new ArrayList<Integer>();

	public ListManager() {
	}

	public List<String> getItems() {
		return items;
	}

	public void loadItems(String fileName) {
		items = new ArrayList<String>();
		try {
			InputStreamReader inputStreamReader = new InputStreamReader(new FileInputStream(fileName), "UTF-8");
//			System.out.println("인풋 스트림 인코딩 : " + inputStreamReader.getEncoding());
			BufferedReader rdr = new BufferedReader(inputStreamReader);
			String line = null;
			while ((line = rdr.readLine()) != null) {
				items.add(line);
//				System.out.println("Item : " + line);
			}
			rdr.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public Set<String> getRandomList(int wantedListSize) {
		subItems = new HashSet<String>();
		for(int i = 0 ; i < wantedListSize ; i++){
			subItems.add(items.get(getRandomNumberNotDuplcated(wantedListSize)));
		}
		subIndexis = new ArrayList<Integer>();
		return subItems;
	}

	public int getRandomNumberNotDuplcated(int wantedListSize) {
		int value = -1;
		int newNumber = (int)(Math.random() * wantedListSize);
		while(value == -1){
			if(!subIndexis.contains(newNumber)){
				value = newNumber;
				subIndexis.add(value);
			}else{
				value = getRandomNumberNotDuplcated(wantedListSize);
			}
		}
		return value;
	}

	public void save(String fileName) {
		try {
			OutputStreamWriter outputStreamWriter = new OutputStreamWriter(new FileOutputStream(fileName), "UTF-8");
//			System.out.println("아웃풋 스트림 인코딩 : " + outputStreamWriter.getEncoding());
			BufferedWriter out = new BufferedWriter(outputStreamWriter);
			Iterator<String> iterator = subItems.iterator();
			while(iterator.hasNext()){
				out.write(iterator.next() + "\n");
			}
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
