package keesun;
import java.util.Iterator;
import java.util.Set;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;


public class RandomListExtracter {

	private static String fileName = null;

	public static void main(String[] args) {

		Display display = new Display();
		final Shell shell = new Shell(display);
		shell.setText("Random List Extracter");
		shell.setImage(new Image(display, "keesun.ico"));


		final ListManager listManager = new ListManager();
		final List list = new List(shell, SWT.BORDER | SWT.SINGLE | SWT.V_SCROLL | SWT.H_SCROLL);
		final List extractedList = new List(shell, SWT.BORDER | SWT.SINGLE | SWT.V_SCROLL | SWT.H_SCROLL);
		//Menu
		Menu menu = new Menu(shell, SWT.BAR);
		shell.setMenuBar(menu);
		MenuItem fileItem = new MenuItem(menu, SWT.CASCADE);
		fileItem.setText("&File");
		Menu submenu = new Menu(shell, SWT.DROP_DOWN);
		fileItem.setMenu(submenu);

		MenuItem item = new MenuItem(submenu, SWT.PUSH);
		item.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event e) {
				if(fileName == null){
					FileDialog dialog = new FileDialog(shell, SWT.SAVE);
					dialog.open();
					fileName = dialog.getFilterPath() + "\\" + dialog.getFileName();
					listManager.save(fileName);
				} else {
					listManager.save(fileName);
				}
			}
		});
		item.setText("&Save\tCtrl+S");
		item.setAccelerator(SWT.MOD1 + 'S');

		item = new MenuItem(submenu, SWT.PUSH);
		item.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event e) {
				FileDialog dialog = new FileDialog(shell, SWT.SAVE);
				dialog.open();
				fileName = dialog.getFilterPath() + "\\" + dialog.getFileName();
				listManager.save(fileName);
			}
		});
		item.setText("Save &As\tCtrl+A");
		item.setAccelerator(SWT.MOD1 + 'A');

		item = new MenuItem(submenu, SWT.PUSH);
		item.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event e) {
				FileDialog dialog = new FileDialog(shell, SWT.OPEN);
				dialog.setFilterExtensions(new String[] {"*.*"});
				dialog.open();
				String fileName = dialog.getFilterPath() + "\\" + dialog.getFileName();
				listManager.loadItems(fileName);
				extractedList.deselectAll();
				fillTotalList(listManager, list);
			}
		});
		item.setText("Load &List\tCtrl+L");
		item.setAccelerator(SWT.MOD1 + 'A');

		//Total List
		list.setBounds(0, 0, 200, 200);

		final Text wantedListSize = new Text(shell, SWT.BORDER | SWT.SINGLE);
		wantedListSize.setBounds(0, 200, 100, 25);
		wantedListSize.addKeyListener(new KeyListener(){
			public void keyPressed(KeyEvent e){
				if(e.keyCode == SWT.CR){
					String text = wantedListSize.getText();
					try{
						int num = Integer.parseInt(text);
						if(num <= listManager.getItems().size())
							fillExtractedList(listManager, extractedList, num);
					}catch (Exception ex) {
						System.out.println("숫자를 잘! 입력해야지");
					}
				}
			}
			public void keyReleased(KeyEvent arg0) {}
		});

		Button extract = new Button(shell, SWT.PUSH);
		extract.setBounds(100, 200, 100, 25);
		extract.setText("Extract");
		extract.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String text = wantedListSize.getText();
				try{
					int num = Integer.parseInt(text);
					if(num < listManager.getItems().size())
						fillExtractedList(listManager, extractedList, num);
				}catch (Exception ex) {
					System.out.println("숫자를 잘! 입력해야지");
				}
			}
		});

		//Extract List
		extractedList.setBounds(200, 0, 200, 200);


		shell.pack();
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	protected static void fillExtractedList(ListManager listManager, List extractedList, int num) {
		extractedList.removeAll();
		Set<String> results = listManager.getRandomList(num);
		Iterator<String> iterator = results.iterator();
		while(iterator.hasNext())
			extractedList.add(iterator.next());
	}

	protected static void fillTotalList(ListManager listManager, List list) {
		list.removeAll();
		java.util.List<String> items = listManager.getItems();
		for(String line : items)
			list.add(line);
	}
}
