package keesun;
import static org.junit.Assert.*;

import java.io.File;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import keesun.ListManager;

import org.junit.Before;
import org.junit.Test;


public class SelecterTest {

	ListManager manager;
	int totalSize;

	@Before public void setup(){
		manager = new ListManager();
		manager.loadItems("test/keesun/list.txt");
		totalSize = manager.getItems().size();
	}

	@Test public void listManeger(){
		List<String> items = manager.getItems();
		assertNotNull(items);
		assertTrue(items.contains("Desprado - Eagles"));
	}

	@Test public void extractRandomList(){
		int listSize = 2;
		Set<String> items = manager.getRandomList(listSize);
		assertTrue(items.size() == 2);
	}

	@Test public void testHashCode(){
		Set<String> stringSet = new HashSet<String>();
		stringSet.add("a");
		stringSet.add("a");
		assertEquals(1, stringSet.size());
	}

	@Test public void getRandomNumberNotDuplicated(){
		Set<Integer> numbers = new HashSet<Integer>();
		int totalListSize = manager.getItems().size();
		int wantedListSize = totalListSize;
		for(int i = 0 ; i < totalListSize ; i++){
			int number = manager.getRandomNumberNotDuplcated(wantedListSize);
			numbers.add(number);
		}
		assertEquals(numbers.size(), totalListSize);
	}

	@Test public void saveNewListToTextFile(){
		int wantedListSize = totalSize;
		Set<String> items = manager.getRandomList(wantedListSize);
		assertEquals(wantedListSize, items.size());

		String saveFileName = "test/keesun/extractedList.txt";
		manager.save(saveFileName);
		assertNotNull(new File(saveFileName));

		manager = new ListManager();
		manager.loadItems(saveFileName);
		assertEquals(wantedListSize, manager.getItems().size());
	}

}
